"use strict";

require("core-js/modules/es.object.assign.js");
require("core-js/modules/es.weak-map.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MyAccountPage = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.promise.js");
var _react = _interopRequireWildcard(require("react"));
var _utils = require("../utils");
var _reactCollapsed = _interopRequireDefault(require("react-collapsed"));
var _svgs = require("../svgs");
var _CoalitionGtm = require("../components/CoalitionGtm/CoalitionGtm");
require("./Pages.scss");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const MyAccountPage = _ref => {
  let {
    movements = [],
    faqs = [],
    gtmId
  } = _ref;
  const [activeMenu, setActiveMenu] = (0, _react.useState)();
  const [content, setContent] = (0, _react.useState)( /*#__PURE__*/_react.default.createElement("h1", {
    className: "landing-message"
  }, "\xA1Bienvenid@ a tu cuenta!"));
  const movsToDraw = movements !== null && movements !== void 0 ? movements : [];
  const movsToDrawFiltered = movsToDraw.filter(mov => mov.data.length > 0);
  const faqsToDraw = faqs !== null && faqs !== void 0 ? faqs : [];
  const buildMovements = async () => {
    await setActiveMenu("movements");
    if (!movsToDrawFiltered || movsToDrawFiltered.length === 0) return;
    await setContent(movsToDrawFiltered.map((movement, k) => /*#__PURE__*/_react.default.createElement(MovementsCard, _extends({
      key: k
    }, movement))));
  };
  const buildHelp = async () => {
    await setActiveMenu("help");
    if (!faqsToDraw || faqsToDraw.length === 0) return;
    await setContent(faqsToDraw.map((block, k) => /*#__PURE__*/_react.default.createElement(FaqsCard, _extends({
      key: k
    }, block, {
      gtmId: gtmId
    }))));
  };
  const klass = function klass(opt) {
    let res = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "option";
    if (activeMenu === opt) res += " selected";
    return res;
  };
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "my-account-page"
  }, activeMenu === "help" ? /*#__PURE__*/_react.default.createElement(ContactUs, {
    gtmId: gtmId
  }) : null, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
    className: "menu"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: klass("movements"),
    onClick: () => {
      (0, _CoalitionGtm.sendTag)(gtmId, (0, _CoalitionGtm.event_13_00)());
      buildMovements();
    }
  }, /*#__PURE__*/_react.default.createElement("div", null, "Movimientos de"), /*#__PURE__*/_react.default.createElement("div", null, "tus puntos")), /*#__PURE__*/_react.default.createElement("div", {
    className: klass("help"),
    onClick: () => buildHelp(gtmId)
  }, "Ayuda")), /*#__PURE__*/_react.default.createElement("div", {
    className: "current-content"
  }, content))));
};
exports.MyAccountPage = MyAccountPage;
const ContactUs = _ref2 => {
  let {
    gtmId
  } = _ref2;
  const launchTag = () => (0, _CoalitionGtm.sendTag)(gtmId, (0, _CoalitionGtm.event_07_01)());
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "contact-us",
    onClick: launchTag
  }, /*#__PURE__*/_react.default.createElement(_svgs.CallCenterIcon, null), /*#__PURE__*/_react.default.createElement("label", null, "Comun\xEDcate con nosotros al: "), /*#__PURE__*/_react.default.createElement("a", {
    href: "tel:+525552695000"
  }, /*#__PURE__*/_react.default.createElement("strong", null, "55 5269 5000")));
};
const FaqsCard = _ref3 => {
  let {
    title,
    data,
    id,
    gtmId
  } = _ref3;
  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
    className: "faq-block-name"
  }, title), data.map((_ref4, idx) => {
    let {
      question,
      answer
    } = _ref4;
    return /*#__PURE__*/_react.default.createElement(FaqRow, {
      key: (0, _utils.makeId)(7),
      question: question,
      answer: answer,
      gtmId: gtmId,
      id: id,
      section: title,
      position: idx + 1
    });
  }));
};
const FaqRow = _ref5 => {
  let {
    question,
    answer,
    gtmId,
    id,
    section,
    position
  } = _ref5;
  const {
    getCollapseProps,
    getToggleProps,
    isExpanded
  } = (0, _reactCollapsed.default)();
  (0, _react.useEffect)(() => {
    const launchTag = async () => {
      if (!isExpanded) return;
      (0, _CoalitionGtm.sendTag)(gtmId, (0, _CoalitionGtm.event_06_00)({
        id,
        section,
        question,
        position
      }));
    };
    launchTag();
  }, [gtmId, id, isExpanded, position, question, section]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "faq-row-container"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "collapsible"
  }, /*#__PURE__*/_react.default.createElement("div", _extends({
    className: "header collapsible-".concat(isExpanded ? "open" : "closed")
  }, getToggleProps()), /*#__PURE__*/_react.default.createElement("label", null, question), /*#__PURE__*/_react.default.createElement("span", null, isExpanded ? /*#__PURE__*/_react.default.createElement(_svgs.ChevronUp, null) : /*#__PURE__*/_react.default.createElement(_svgs.ChevronDown, null))), /*#__PURE__*/_react.default.createElement("div", getCollapseProps(), /*#__PURE__*/_react.default.createElement("div", {
    className: "content"
  }, answer))));
};
const MovementsCard = _ref6 => {
  let {
    title,
    data
  } = _ref6;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "movement-card"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "movement-card-date"
  }, Titlelize(title)), data.map((info, i) => /*#__PURE__*/_react.default.createElement(MovementRow, _extends({
    key: i
  }, info))));
};
const MovementRow = _ref7 => {
  let {
    sponsor_name,
    location_name,
    brand_image,
    bits,
    is_accrual,
    transaction_id,
    transaction_date,
    transaction_type
  } = _ref7;
  const formattedDate = new Date(transaction_date).toLocaleDateString("es-mx", {
    weekday: "long",
    // year: "numeric",
    // month: "long",
    day: "numeric"
  });
  const FormattedBits = _ref8 => {
    let {
      bits,
      isAcc = true
    } = _ref8;
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("label", {
      style: {
        color: "#4a90e2"
      }
    }, isAcc ? "+" : "-"), /*#__PURE__*/_react.default.createElement(_utils.MakePriceWithCents, {
      bits: bits
    }));
  };
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "movement-container"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "container-logo"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "logo"
  }, /*#__PURE__*/_react.default.createElement("img", {
    src: brand_image,
    alt: "logo"
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: "container-description"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "description"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "title"
  }, sponsor_name), /*#__PURE__*/_react.default.createElement("div", {
    className: "detail"
  }, Titlelize(formattedDate)))), /*#__PURE__*/_react.default.createElement("div", {
    className: "container-ammount"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "ammount"
  }, /*#__PURE__*/_react.default.createElement(FormattedBits, {
    bits: bits,
    isAcc: is_accrual
  })))));
};
const Titlelize = str => str.charAt(0).toUpperCase() + str.slice(1);